GLOBAL DNRM2		; Hiermit wird die Funktion AssFunc externen 
                        ; Programmen zugnglich gemacht

SECTION .data
minusone: dw -1
minustwo: dw -2

SECTION .text

;====================================================
;----------------------------------------------------
;====================================================

DNRM2:
        PUSH EBP		;BasePointer retten
	MOV EBP,ESP		;Stackpointer zum neuen BasePointer machen
				;(Bezugspunkt fr Parameterbergabe festlegen)

        ; der erste uebergebene Parameter befindet sich
        ; auf [EBP+8], der zweite auf [EBP+8+Anzahl Bytes des Parameters] etc.
        ; (4 Byte R~Acksprungadresse plus 4 Byte fuer EBP)
	; der Einfachheit halber kopieren wir den ersten Parameter in EAX
	; Parameter n in EAX, x in EBX, incx in ECX
	MOV EAX,[EBP+8]
	MOV EBX, [EBP+12]
	MOV ECX, [EBP+16]

	; 0 in den FPU Stack laden
	FLDZ
	; Ungueltige Eingaben abfangen
	CMP EAX, 0
	JE nisnull
	JL invalidinput
	CMP EBX, 0
	JE invalidinput
	CMP ECX, 0
	JLE invalidinput
loopt:
	; Komponente in den FPU Stack laden
	FLD QWORD [EBX]
	; Quadrieren
	FMUL ST0
	; Zu bisherigem Ergebnis aufaddieren
	FADDP ST1, ST0
	; n dekrementieren, Speicheraddresse um incx erhhen und gegebenfalls (n == 0) abbrechen
	DEC EAX
	ADD EBX, ECX
	CMP EAX, 0
	JNE loopt
	; Wurzel ziehen
	FSQRT
nisnull:
	; FPU ist schon mit 0 geladen
	JMP ende
invalidinput:
	; -1 in FPU
	FILD WORD [minusone]
	JMP ende
ende:
        POP EBP                 ;BP wiederherstellen
        RET

